## meganz-sdk-v10.3.1.tar.gz

=== CMakeLists.txt ===
# CMakeLists.txt file to build the SDKlib library.
#
# It can be used to build a standalone library or to be included via add_subdirectory.
#
# To include the project in your application use the following:
#    add_subdirectory(path/to/sdk)
#    target_link_libraries(<target> PRIVATE MEGA::SDKlib)
#
# To use it as a standalone library, once compiled and installed:
#    find_package(SDKlib REQUIRED)
#    target_link_libraries(<target> PRIVATE MEGA::SDKlib)
# If you prefer to use pkg-config, use the following instead:
#    pkg_check_modules(SDKlib REQUIRED IMPORTED_TARGET SDKlib)
#    target_link_libraries(<target> PRIVATE PkgConfig::SDKlib)
#

cmake_minimum_required(VERSION 3.20)

# Qt Creator configures VCPKG automatically. Disable it, we may want to use different tripplets, paths...
set(QT_CREATOR_SKIP_VCPKG_SETUP TRUE CACHE BOOL "")

# Main modules location
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules)

set(VCPKG_ROOT "" CACHE PATH "If set, it will build and use the VCPKG packages defined in the manifest file")

## Configurable options ##
include(sdklib_options)

# If PROJECT_NAME is not set before project() we are the main project.
if(NOT PROJECT_NAME)
    message(STATUS "[SDKlib] is a top-level project. Install target is enabled by default.")
    set(SDKLIB_STANDALONE 1)
    if (CMAKE_SYSTEM_NAME STREQUAL "iOS" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
        message(STATUS "Examples and tests will not be enabled by default for ${CMAKE_SYSTEM_NAME} builds")
        option(ENABLE_SDKLIB_EXAMPLES "Example application is built if enabled" OFF)
        option(ENABLE_SDKLIB_TESTS "Integration and unit tests are built if enabled" OFF)
    else()
        message(STATUS "Examples and tests will be enabled by default.")
        option(ENABLE_SDKLIB_EXAMPLES "Example application is built if enabled" ON)
        option(ENABLE_SDKLIB_TESTS "Integration and unit tests are built if enabled" ON)
    endif()
    option(ENABLE_SDKLIB_WERROR "Enable warnings as errors" ON)
else()
    message(STATUS "[SDKlib] is building under project [${PROJECT_NAME}] Install target, examples and tests will not be enabled by default.")
    set(SDKLIB_STANDALONE 0)
    option(ENABLE_SDKLIB_EXAMPLES "Example application is built if enabled" OFF)
    option(ENABLE_SDKLIB_TESTS "Integration and unit tests are built if enabled" OFF)
    option(ENABLE_SDKLIB_WERROR "Enable warnings as errors." OFF)
endif()

## General configuration

include(sdklib_variables)

if(NOT PROJECT_NAME)
    if(VCPKG_ROOT)
        # Include VCPKG management tools.
        include(vcpkg_management)
        process_vcpkg_libraries(${CMAKE_CURRENT_LIST_DIR}/cmake)
    else()
        # For packages with no pkg-config in the system.
        list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules/packages)
        message(STATUS "Using system dependencies")
    endif()
endif()

# Get SDK library version to use it as the CMake project version.
include(load_sdk_version)
read_sdk_version(MEGA_SDK_VERSION ${CMAKE_CURRENT_LIST_DIR}/include/mega/version.h)

project(SDKlib
    VERSION ${MEGA_SDK_VERSION}
    DESCRIPTION "MEGA SDK Library"
    )

# In-source build not allowed
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
    message(FATAL_ERROR "In-source build is not allowed. Remove CMakeCache.txt and the CMakeFiles directory and set a new binary directory different than the source tree.")
endif()

message(STATUS "Generator: ${CMAKE_GENERATOR}")
if(CMAKE_SYSTEM_VERSION)
    message(STATUS "Target OS version: ${CMAKE_SYSTEM_VERSION}")
endif()
if(CMAKE_GENERATOR_PLATFORM)
    message(STATUS "Platform: ${CMAKE_GENERATOR_PLATFORM}")
endif()
if(APPLE)
    if(CMAKE_OSX_ARCHITECTURES)
        message(STATUS "Architectures: ${CMAKE_OSX_ARCHITECTURES}")
    else()
        message(STATUS "Architectures: -Not set- (It defaults to the host system architecture)")
    endif()
    message(STATUS "Minimum deployment version: ${CMAKE_OSX_DEPLOYMENT_TARGET}")
    if(CMAKE_OSX_SYSROOT)
        message(STATUS "Platform SDK: ${CMAKE_OSX_SYSROOT}")
    endif()
endif()
message(STATUS "Target System Processor: ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "Host System Processor: ${CMAKE_HOST_SYSTEM_PROCESSOR}")

get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(IS_MULTI_CONFIG)
    if(CMAKE_CONFIGURATION_TYPES)
        message(STATUS "Generated with config types: ${CMAKE_CONFIGURATION_TYPES}")
    else()
        message(FATAL_ERROR "You must specify CMAKE_CONFIGURATION_TYPES")
    endif()
else()
    if(CMAKE_BUILD_TYPE)
        message(STATUS "Build type set to: ${CMAKE_BUILD_TYPE}")
    else()
        message(FATAL_ERROR "You must specify CMAKE_BUILD_TYPE. For example: -DCMAKE_BUILD_TYPE=Debug")
    endif()
endif()

if($ENV{CFLAGS})
    message(STATUS "Environment CFLAGS: $ENV{CFLAGS}")
endif()
if($ENV{CXXFLAGS})
    message(STATUS "Environment CXXFLAGS: $ENV{CXXFLAGS}")
endif()
if($ENV{LDFLAGS})
    message(STATUS "Environment LDFLAGS: $ENV{LDFLAGS}")
endif()

if(USE_READLINE AND WIN32)
    message(FATAL_ERROR "Readline is not available in Windows builds. Disable USE_READLINE to continue.")
endif()

if(ENABLE_ISOLATED_GFX AND NOT USE_FREEIMAGE)
    message(FATAL_ERROR "USE_FREEIMAGE is required when ENABLE_ISOLATED_GFX is enabled.")
endif()

if(NOT ENABLE_MEDIA_FILE_METADATA AND USE_MEDIAINFO)
    message(FATAL_ERROR "Use ENABLE_MEDIA_FILE_METADATA option instead of USE_MEDIAINFO")
endif()

message(STATUS "Building SDKlib v${PROJECT_VERSION}")

include(GNUInstallDirs) # Values for installation directories. All platforms
include(CMakePackageConfigHelpers) # For the CMake package
include(target_sources_conditional) # To add files to the project without building them
include(target_platform_compile_options) # To add compile options depeding on the platform
include(target_arch_compile_options) # To add compile options depeding on the architecture
include(sdklib_libraries) # Includes a macro to load the dependencies, both the VCPKG or the system ones.

# Load common and per platform configuration for the project
include(configuration)

## Start loading targets
include(sdklib_target)

# Load Qt bindings
if(ENABLE_QT_BINDINGS)
    add_subdirectory(bindings/qt)
endif()

# Load Java bindings
if(ENABLE_JAVA_BINDINGS)
    add_subdirectory(bindings/java)
endif()

if(ENABLE_ISOLATED_GFX)
    add_subdirectory(tools/gfxworker)
endif()

## Load examples and tests
if(ENABLE_SDKLIB_EXAMPLES)
    add_subdirectory(examples)
endif()

if(ENABLE_SDKLIB_TESTS)
    add_subdirectory(tests)
endif()

## Load FUSE support.
add_subdirectory(src/fuse)

add_subdirectory(third_party)

=== bindings/java/CMakeLists.txt ===
find_package(Java REQUIRED)
find_package(SWIG REQUIRED)
include(UseSWIG)

# Set the output directory for generated Java files
set(JAVA_OUTPUT_DIR ${CMAKE_BINARY_DIR}/bindings/java/nz/mega/sdk)

# Define the interface file and its properties
set(SWIG_INTERFACE_FILE ${CMAKE_CURRENT_LIST_DIR}/../megaapi.i)
set_source_files_properties(${SWIG_INTERFACE_FILE} PROPERTIES
    CPLUSPLUS ON
)

# Set SWIG flags for generating Java code
if(ENABLE_SYNC)
    list(APPEND ADDITIONAL_SDK_SWIG_DEFINES -DENABLE_SYNC)
endif()

if(USE_LIBUV)
    list(APPEND ADDITIONAL_SDK_SWIG_DEFINES -DHAVE_LIBUV)
endif()

if(ENABLE_CHAT)
    list(APPEND ADDITIONAL_SDK_SWIG_DEFINES -DENABLE_CHAT)
endif()

if(ENABLE_LOG_PERFORMANCE)
    list(APPEND ADDITIONAL_SDK_SWIG_DEFINES -DENABLE_LOG_PERFORMANCE)
endif()

set(CMAKE_SWIG_FLAGS -c++ -package "nz.mega.sdk" ${ADDITIONAL_SDK_SWIG_DEFINES} -I${CMAKE_CURRENT_LIST_DIR}/../../include)

set(SDKLIB_ANDROID_LIBRARY_TYPE USE_BUILD_SHARED_LIBS)
if(ENABLE_SDKLIB_ANDROID_DYNAMIC_LIBRARY)
    set(SDKLIB_ANDROID_LIBRARY_TYPE SHARED)
endif()

# Generate java binding files
swig_add_library(SDKJavaBindings
    TYPE ${SDKLIB_ANDROID_LIBRARY_TYPE}
    LANGUAGE java
    SOURCES ${SWIG_INTERFACE_FILE}
    OUTPUT_DIR ${JAVA_OUTPUT_DIR}
)

if (ENABLE_SDKLIB_ANDROID_DYNAMIC_LIBRARY)
    # Rename when a single dynamic library is produced
    set_target_properties(SDKJavaBindings PROPERTIES
      OUTPUT_NAME "mega" # libmega.so
    )
endif()

set_target_properties(SDKJavaBindings PROPERTIES
    POSITION_INDEPENDENT_CODE ON
)

# For Android we do not need JNI
if(ANDROID)
    set(JNI_INCLUDE_DIRS
        ${ANDROID_NDK_HOME}/sysroot/usr/include
        ${ANDROID_NDK_HOME}/sysroot/usr/include/${ANDROID_ABI}
    )
else()
    find_package(JNI REQUIRED)
endif()

# If the library needs JNI_OnLoad
if(SDKLIB_STANDALONE AND (BUILD_SHARED_LIBS OR ENABLE_SDKLIB_ANDROID_DYNAMIC_LIBRARY))
    message(STATUS "JNI_OnLoad will be available in the SDK bindings dynamic library.")
    target_compile_definitions(SDKJavaBindings
        PRIVATE
        SDKLIB_ONLOAD
    )
endif()

target_include_directories(SDKJavaBindings
    PRIVATE
    ${Java_INCLUDE_DIRS}
    ${JNI_INCLUDE_DIRS}
    ${JAVA_OUTPUT_DIR}
)

target_link_libraries(SDKJavaBindings
    PRIVATE
    MEGA::SDKlib
)

# Compile Java code
add_custom_command(TARGET SDKJavaBindings POST_BUILD
    COMMAND ${Java_JAVAC_EXECUTABLE} -d ${JAVA_OUTPUT_DIR} -cp ${JAVA_OUTPUT_DIR} ${JAVA_OUTPUT_DIR}/*.java
    COMMENT "Compiling Java classes..."
)

=== src/fuse/CMakeLists.txt ===
# Let the user know that they can build with FUSE support.
option(WITH_FUSE "Build with FUSE support." OFF)

# Add sources required by all backends.
add_subdirectory(common)

# Does the user want FUSE support built in?
if (WITH_FUSE)
    # Yep so build platform-specific backend.
    add_subdirectory(supported)
else()
    # Nope so build the dummy backend.
    add_subdirectory(unsupported)
endif()

=== tests/integration/CMakeLists.txt ===
add_executable(test_integration)

target_sources(test_integration
    PRIVATE
    env_var_accounts.h
    SdkTest_test.h
    SdkTestNodesSetUp.h
    SdkTestSyncNodesOperations.h
    SdkTestSyncPrevalidation.h
    test.h
    integration_test_utils.h
    mock_listeners.h

    env_var_accounts.cpp
    main.cpp
    SdkTest_test.cpp
    SdkTestNodesSetUp.cpp
    SdkTestSyncNodesOperations.cpp
    SdkTestFilter_test.cpp
    SdkTestCreateAccount_test.cpp
    SdkTestTransferStats_test.cpp
    sdk_test_user_alerts.cpp
    sdk_test_user_attributes.cpp
    SdkTestSyncRootOperations_test.cpp
    SdkTestSyncUploadThrottling_test.cpp
    SdkTestChangeLocalSyncRoot_test.cpp
    SdkTestSyncPrevalidation.cpp
    SdkTestSyncPrevalidation_test.cpp
    Sync_test.cpp
    one_question_survey_test.cpp
    share_test.cpp
    integration_test_utils.cpp
    DisableBackupSync_test.cpp
    SdkTestTransferMaxSpeeds_test.cpp
    sdk_test_file_path.cpp
    sdk_test_http_server.cpp
    sdk_test_node_tags.cpp
    sdk_test_node_tags.h
    sdk_test_network.cpp
    sdk_test_sync_upload_operations_test.cpp
    backup_test_utils.h
    sdk_test_backup_upload_operations_test.cpp
    SdkTestDeviceCenter_test.cpp
    SdkTestSyncLocalOperations_test.cpp
    SdkTestSyncNodeAttribute_test.cpp
    SdkTestCaseInsensitiveCollision_test.cpp
    backup_sync_operations_test.cpp
    sdk_test_lockless_cs_channel.cpp
    SdkTestFolderController_test.cpp

    passwordManager/SdkTestPasswordManager.cpp
    passwordManager/SdkTestPasswordManager.h
    passwordManager/SdkTestPasswordManagerBaseNode_test.cpp
    passwordManager/SdkTestPasswordManagerImport_test.cpp
    passwordManager/SdkTestPasswordManagerPassFolderCRUD_test.cpp
    passwordManager/SdkTestPasswordManagerPassNodeCRUD_test.cpp
    passwordManager/SdkTestPasswordManagerCreditCardNodeCRUD_test.cpp
)

target_sources_conditional(test_integration
    FLAG ENABLE_ISOLATED_GFX
    PRIVATE
    IsolatedGfx_test.cpp
)

# Load common test sources.
include(common/common.cmake)

# Load File Service test sources.
include(file_service/file_service.cmake)

# Link with SDKlib
target_link_libraries(test_integration PRIVATE MEGA::SDKlib)

# Link with the common and tools interface libraries for the tests.
target_link_libraries(test_integration
    PRIVATE
    MEGA::test_tools
    MEGA::test_common
)

target_include_directories(test_integration
    PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
)

# Adjust compilation flags for warnings and errors
target_platform_compile_options(
    TARGET test_integration
    WINDOWS /bigobj /we4800 # Implicit conversion from 'type' to bool. Possible information loss
    UNIX $<$<CONFIG:Debug>:-ggdb3> -Wall -Wextra -Wconversion
)

if(ENABLE_SDKLIB_WERROR)
    target_platform_compile_options(
        TARGET test_integration
        WINDOWS /WX
        UNIX  $<$<CONFIG:Debug>: -Werror>
    )
endif()

# Integration tests require the following files to work
file(GLOB TESTING_AUX_FILES "test-data/*")
add_custom_command(
    TARGET test_integration POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${TESTING_AUX_FILES} $<TARGET_FILE_DIR:test_integration>
    COMMENT "Copying test files for integration tests."
)

if(TARGET gfxworker)
    add_custom_command(
        TARGET test_integration POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gfxworker> $<TARGET_FILE_DIR:test_integration>
        COMMENT "Copying gfxworker for integration tests."
    )
endif()

=== tests/unit/CMakeLists.txt ===
add_executable(test_unit)

target_sources(test_unit
    PRIVATE
    constants.h
    DefaultedDbTable.h
    DefaultedDirAccess.h
    DefaultedFileAccess.h
    DefaultedFileSystemAccess.h
    FsNode.h
    NotImplemented.h
    utils.h

    main.cpp
    Arguments_test.cpp
    AttrMap_test.cpp
    CacheLRU_test.cpp
    canceller_test.cpp
    ChunkMacMap_test.cpp
    Commands_test.cpp
    Crypto_test.cpp
    FileFingerprint_test.cpp
    FileFingerprint_CRC_test.cpp
    File_test.cpp
    FsNode.cpp
    hashcash_test.cpp
    Logging_test.cpp
    MediaProperties_test.cpp
    MegaApi_test.cpp
    NodesMatchedByFsid_test.cpp
    name_collision_test.cpp
    PayCrypter_test.cpp
    PendingContactRequest_test.cpp
    proxy_test.cpp
    Scoped_timer_test.cpp
    Serialization_test.cpp
    Share_test.cpp
    Sync_conflict_test.cpp
    Sync_test.cpp
    SyncUploadThrottling_test.cpp
    TextChat_test.cpp
    Transfer_test.cpp
    Transferstats_test.cpp
    User_test.cpp
    user_attributes_test.cpp
    impl/share_test.cpp
    utils.cpp
    utils_test.cpp
    utils_optional_test.cpp
    pwm_file_parser_test.cpp
    pwm_import_validation.cpp
    LRUCache_test.cpp
    totp_test.cpp
    localpath_test.cpp
    shared_mutex_tests.cpp
    uripath_test.cpp
    Sqlite_test.cpp
    file_access_tests.cpp
    jsonsplitter_test.cpp
)

target_sources_conditional(test_unit
    FLAG ENABLE_ISOLATED_GFX
    PRIVATE
    Isolatedprocess_test.cpp
    GfxCommands_test.cpp
)

# Load File Service test sources.
include(file_service/file_service.cmake)

# Link with SDKlib
target_link_libraries(test_unit PRIVATE
                                MEGA::CommonHeaderPaths
                                MEGA::SDKlib
)

# Link with the common interface library for the tests.
target_link_libraries(test_unit PRIVATE MEGA::test_tools MEGA::test_common)

# Adjust compilation flags for warnings and errors
target_platform_compile_options(
    TARGET test_unit
    WINDOWS /we4800 # Implicit conversion from 'type' to bool. Possible information loss
    UNIX $<$<CONFIG:Debug>:-ggdb3> -Wall -Wextra -Wconversion
)

if(ENABLE_SDKLIB_WERROR)
    target_platform_compile_options(
        TARGET test_unit
        WINDOWS /WX
        UNIX  $<$<CONFIG:Debug>: -Werror>
    )
endif()

=== cmake/vcpkg_overlay_ports/pdfium/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.19)
project(pdfium_by_cmake)

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -DDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG -DDEBUG")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(WIN32)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /EHsc /MP")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP ")
	add_definitions(-DHAVE_BOOLEAN -DNOMINMAX -DWIN32_LEAN_AND_MEAN)
endif()

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk" )
endif()

add_definitions(-DCMS_NO_REGISTER_KEYWORD -DUNICODE -D_UNICODE -DUSE_LIBJPEG_TURBO -DPNG_PREFIX -DUSE_SYSTEM_ICUUC -DUSE_SYSTEM_LIBJPEG -DUSE_SYSTEM_LCMS2 -DUSE_SYSTEM_ZLIB -DUSE_SYSTEM_LIBOPENJPEG2 -DOPJ_STATIC -DDEFINE_PS_TABLES)
# no skia, V8, or xfa (xfa seems to require V8 anyway)

find_package(OpenJPEG          REQUIRED)
find_package(lcms              REQUIRED)
find_package(JPEG              REQUIRED)
find_package(libpng            REQUIRED)
find_package(Freetype          REQUIRED)
find_package(ICU COMPONENTS uc REQUIRED)

include_directories(
    ${JPEG_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/third_party/abseil-cpp
    "."
)

if(WIN32)
     set(WIN 1)
else()
     set(WIN 0)
endif()

if (APPLE)
    set(MAC 1)
else()
    set(MAC 0)
endif()

if (NOT WIN32 AND NOT APPLE)
    set(LINUX 1)
else()
    set(LINUX 0)
endif()

set(ANDROID 0)


add_library(pdfium STATIC)

# File extraction:
# Configure the project using the depot_tools, using the following parameters. It may require some adjustments depending on the OS:
#    gn gen ../out/build_x64 --args="is_component_build=false use_custom_libcxx=false treat_warnings_as_errors=false fatal_linker_warnings=false pdf_enable_v8=false pdf_is_complete_lib=true use_sysroot=false is_clang=false is_debug=true"
# Compile with ninja using -v and -j1 parameters.
#    ninja -C ../out/build_x64 -j1 -v :pdfium > build_output.txt
# Process the output with the following AWK script:
# awk '
# {
#   for (i = 1; i < NF; i++) {
#     if ($i ~ /\.(c|cc|cpp|cxx|C|c\+\+)$/ && ($(i+1) == "-o" || $(i+1) ~ /\.(obj)$/)) {
#       sub("^\\.\\.\\/\\.\\.\\/pdfium/", "", $i)
#       print $i
#     }
#   }
# }
# ' build_output.txt > build_output_processed.txt
# Output will need some manual parsing and adjustments.
target_sources(pdfium PRIVATE
constants/annotation_common.cpp
constants/appearance.cpp
constants/font_encodings.cpp
constants/form_fields.cpp
constants/page_object.cpp
constants/stream_dict_common.cpp
constants/transparency.cpp
core/fdrm/fx_crypt.cpp
core/fdrm/fx_crypt_aes.cpp
core/fdrm/fx_crypt_sha.cpp
core/fpdfapi/cmaps/CNS1/Adobe-CNS1-UCS2_5.cpp
core/fpdfapi/cmaps/CNS1/B5pc-H_0.cpp
core/fpdfapi/cmaps/CNS1/B5pc-V_0.cpp
core/fpdfapi/cmaps/CNS1/CNS-EUC-H_0.cpp
core/fpdfapi/cmaps/CNS1/CNS-EUC-V_0.cpp
core/fpdfapi/cmaps/CNS1/ETen-B5-H_0.cpp
core/fpdfapi/cmaps/CNS1/ETen-B5-V_0.cpp
core/fpdfapi/cmaps/CNS1/ETenms-B5-H_0.cpp
core/fpdfapi/cmaps/CNS1/ETenms-B5-V_0.cpp
core/fpdfapi/cmaps/CNS1/HKscs-B5-H_5.cpp
core/fpdfapi/cmaps/CNS1/HKscs-B5-V_5.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-H_3.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-V_3.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UTF16-H_0.cpp
core/fpdfapi/cmaps/CNS1/cmaps_cns1.cpp
core/fpdfapi/cmaps/GB1/Adobe-GB1-UCS2_5.cpp
core/fpdfapi/cmaps/GB1/GB-EUC-H_0.cpp
core/fpdfapi/cmaps/GB1/GB-EUC-V_0.cpp
core/fpdfapi/cmaps/GB1/GBK-EUC-H_2.cpp
core/fpdfapi/cmaps/GB1/GBK-EUC-V_2.cpp
core/fpdfapi/cmaps/GB1/GBK2K-H_5.cpp
core/fpdfapi/cmaps/GB1/GBK2K-V_5.cpp
core/fpdfapi/cmaps/GB1/GBKp-EUC-H_2.cpp
core/fpdfapi/cmaps/GB1/GBKp-EUC-V_2.cpp
core/fpdfapi/cmaps/GB1/GBpc-EUC-H_0.cpp
core/fpdfapi/cmaps/GB1/GBpc-EUC-V_0.cpp
core/fpdfapi/cmaps/GB1/UniGB-UCS2-H_4.cpp
core/fpdfapi/cmaps/GB1/UniGB-UCS2-V_4.cpp
core/fpdfapi/cmaps/GB1/cmaps_gb1.cpp
core/fpdfapi/cmaps/Japan1/83pv-RKSJ-H_1.cpp
core/fpdfapi/cmaps/Japan1/90ms-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/90ms-RKSJ-V_2.cpp
core/fpdfapi/cmaps/Japan1/90msp-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/90msp-RKSJ-V_2.cpp
core/fpdfapi/cmaps/Japan1/90pv-RKSJ-H_1.cpp
core/fpdfapi/cmaps/Japan1/Add-RKSJ-H_1.cpp
core/fpdfapi/cmaps/Japan1/Add-RKSJ-V_1.cpp
core/fpdfapi/cmaps/Japan1/Adobe-Japan1-UCS2_4.cpp
core/fpdfapi/cmaps/Japan1/EUC-H_1.cpp
core/fpdfapi/cmaps/Japan1/EUC-V_1.cpp
core/fpdfapi/cmaps/Japan1/Ext-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/Ext-RKSJ-V_2.cpp
core/fpdfapi/cmaps/Japan1/H_1.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-H_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-V_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-H_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-V_4.cpp
core/fpdfapi/cmaps/Japan1/V_1.cpp
core/fpdfapi/cmaps/Japan1/cmaps_japan1.cpp
core/fpdfapi/cmaps/Korea1/Adobe-Korea1-UCS2_2.cpp
core/fpdfapi/cmaps/Korea1/KSC-EUC-H_0.cpp
core/fpdfapi/cmaps/Korea1/KSC-EUC-V_0.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-H_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-V_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-H_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-V_1.cpp
core/fpdfapi/cmaps/Korea1/KSCpc-EUC-H_0.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UCS2-H_1.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UCS2-V_1.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UTF16-H_0.cpp
core/fpdfapi/cmaps/Korea1/cmaps_korea1.cpp
core/fpdfapi/cmaps/fpdf_cmaps.cpp
core/fpdfapi/edit/cpdf_contentstream_write_utils.cpp
core/fpdfapi/edit/cpdf_creator.cpp
core/fpdfapi/edit/cpdf_npagetooneexporter.cpp
core/fpdfapi/edit/cpdf_pagecontentgenerator.cpp
core/fpdfapi/edit/cpdf_pagecontentmanager.cpp
core/fpdfapi/edit/cpdf_pageexporter.cpp
core/fpdfapi/edit/cpdf_pageorganizer.cpp
core/fpdfapi/edit/cpdf_stringarchivestream.cpp
core/fpdfapi/font/cfx_cttgsubtable.cpp
core/fpdfapi/font/cfx_stockfontarray.cpp
core/fpdfapi/font/cpdf_cid2unicodemap.cpp
core/fpdfapi/font/cpdf_cidfont.cpp
core/fpdfapi/font/cpdf_cmap.cpp
core/fpdfapi/font/cpdf_cmapparser.cpp
core/fpdfapi/font/cpdf_font.cpp
core/fpdfapi/font/cpdf_fontencoding.cpp
core/fpdfapi/font/cpdf_fontglobals.cpp
core/fpdfapi/font/cpdf_simplefont.cpp
core/fpdfapi/font/cpdf_tounicodemap.cpp
core/fpdfapi/font/cpdf_truetypefont.cpp
core/fpdfapi/font/cpdf_type1font.cpp
core/fpdfapi/font/cpdf_type3char.cpp
core/fpdfapi/font/cpdf_type3font.cpp
core/fpdfapi/page/cpdf_allstates.cpp
core/fpdfapi/page/cpdf_annotcontext.cpp
core/fpdfapi/page/cpdf_basedcs.cpp
core/fpdfapi/page/cpdf_clippath.cpp
core/fpdfapi/page/cpdf_color.cpp
core/fpdfapi/page/cpdf_colorspace.cpp
core/fpdfapi/page/cpdf_colorstate.cpp
core/fpdfapi/page/cpdf_contentmarkitem.cpp
core/fpdfapi/page/cpdf_contentmarks.cpp
core/fpdfapi/page/cpdf_contentparser.cpp
core/fpdfapi/page/cpdf_devicecs.cpp
core/fpdfapi/page/cpdf_dib.cpp
core/fpdfapi/page/cpdf_docpagedata.cpp
core/fpdfapi/page/cpdf_expintfunc.cpp
core/fpdfapi/page/cpdf_form.cpp
core/fpdfapi/page/cpdf_formobject.cpp
core/fpdfapi/page/cpdf_function.cpp
core/fpdfapi/page/cpdf_generalstate.cpp
core/fpdfapi/page/cpdf_graphicstates.cpp
core/fpdfapi/page/cpdf_iccprofile.cpp
core/fpdfapi/page/cpdf_image.cpp
core/fpdfapi/page/cpdf_imageloader.cpp
core/fpdfapi/page/cpdf_imageobject.cpp
core/fpdfapi/page/cpdf_indexedcs.cpp
core/fpdfapi/page/cpdf_meshstream.cpp
core/fpdfapi/page/cpdf_occontext.cpp
core/fpdfapi/page/cpdf_page.cpp
core/fpdfapi/page/cpdf_pageimagecache.cpp
core/fpdfapi/page/cpdf_pagemodule.cpp
core/fpdfapi/page/cpdf_pageobject.cpp
core/fpdfapi/page/cpdf_pageobjectholder.cpp
core/fpdfapi/page/cpdf_path.cpp
core/fpdfapi/page/cpdf_pathobject.cpp
core/fpdfapi/page/cpdf_pattern.cpp
core/fpdfapi/page/cpdf_patterncs.cpp
core/fpdfapi/page/cpdf_psengine.cpp
core/fpdfapi/page/cpdf_psfunc.cpp
core/fpdfapi/page/cpdf_sampledfunc.cpp
core/fpdfapi/page/cpdf_shadingobject.cpp
core/fpdfapi/page/cpdf_shadingpattern.cpp
core/fpdfapi/page/cpdf_stitchfunc.cpp
core/fpdfapi/page/cpdf_streamcontentparser.cpp
core/fpdfapi/page/cpdf_streamparser.cpp
core/fpdfapi/page/cpdf_textobject.cpp
core/fpdfapi/page/cpdf_textstate.cpp
core/fpdfapi/page/cpdf_tilingpattern.cpp
core/fpdfapi/page/cpdf_transferfunc.cpp
core/fpdfapi/page/cpdf_transferfuncdib.cpp
core/fpdfapi/page/cpdf_transparency.cpp
core/fpdfapi/parser/cfdf_document.cpp
core/fpdfapi/parser/cpdf_array.cpp
core/fpdfapi/parser/cpdf_boolean.cpp
core/fpdfapi/parser/cpdf_cross_ref_avail.cpp
core/fpdfapi/parser/cpdf_cross_ref_table.cpp
core/fpdfapi/parser/cpdf_crypto_handler.cpp
core/fpdfapi/parser/cpdf_data_avail.cpp
core/fpdfapi/parser/cpdf_dictionary.cpp
core/fpdfapi/parser/cpdf_document.cpp
core/fpdfapi/parser/cpdf_encryptor.cpp
core/fpdfapi/parser/cpdf_flateencoder.cpp
core/fpdfapi/parser/cpdf_hint_tables.cpp
core/fpdfapi/parser/cpdf_indirect_object_holder.cpp
core/fpdfapi/parser/cpdf_linearized_header.cpp
core/fpdfapi/parser/cpdf_name.cpp
core/fpdfapi/parser/cpdf_null.cpp
core/fpdfapi/parser/cpdf_number.cpp
core/fpdfapi/parser/cpdf_object.cpp
core/fpdfapi/parser/cpdf_object_avail.cpp
core/fpdfapi/parser/cpdf_object_stream.cpp
core/fpdfapi/parser/cpdf_object_walker.cpp
core/fpdfapi/parser/cpdf_page_object_avail.cpp
core/fpdfapi/parser/cpdf_parser.cpp
core/fpdfapi/parser/cpdf_read_validator.cpp
core/fpdfapi/parser/cpdf_reference.cpp
core/fpdfapi/parser/cpdf_security_handler.cpp
core/fpdfapi/parser/cpdf_simple_parser.cpp
core/fpdfapi/parser/cpdf_stream.cpp
core/fpdfapi/parser/cpdf_stream_acc.cpp
core/fpdfapi/parser/cpdf_string.cpp
core/fpdfapi/parser/cpdf_syntax_parser.cpp
core/fpdfapi/parser/fpdf_parser_decode.cpp
core/fpdfapi/parser/fpdf_parser_utility.cpp
core/fpdfapi/parser/object_tree_traversal_util.cpp
core/fpdfapi/render/charposlist.cpp
core/fpdfapi/render/cpdf_devicebuffer.cpp
core/fpdfapi/render/cpdf_docrenderdata.cpp
core/fpdfapi/render/cpdf_imagerenderer.cpp
core/fpdfapi/render/cpdf_pagerendercontext.cpp
core/fpdfapi/render/cpdf_progressiverenderer.cpp
core/fpdfapi/render/cpdf_rendercontext.cpp
core/fpdfapi/render/cpdf_renderoptions.cpp
core/fpdfapi/render/cpdf_rendershading.cpp
core/fpdfapi/render/cpdf_renderstatus.cpp
core/fpdfapi/render/cpdf_rendertiling.cpp
core/fpdfapi/render/cpdf_textrenderer.cpp
core/fpdfapi/render/cpdf_type3cache.cpp
core/fpdfapi/render/cpdf_type3glyphmap.cpp
$<${WIN}:core/fpdfapi/render/cpdf_scaledrenderbuffer.cpp>
$<${WIN}:core/fpdfapi/render/cpdf_windowsrenderdevice.cpp>
core/fpdfdoc/cpdf_aaction.cpp
core/fpdfdoc/cpdf_action.cpp
core/fpdfdoc/cpdf_annot.cpp
core/fpdfdoc/cpdf_annotlist.cpp
core/fpdfdoc/cpdf_apsettings.cpp
core/fpdfdoc/cpdf_bafontmap.cpp
core/fpdfdoc/cpdf_bookmark.cpp
core/fpdfdoc/cpdf_bookmarktree.cpp
core/fpdfdoc/cpdf_color_utils.cpp
core/fpdfdoc/cpdf_defaultappearance.cpp
core/fpdfdoc/cpdf_dest.cpp
core/fpdfdoc/cpdf_filespec.cpp
core/fpdfdoc/cpdf_formcontrol.cpp
core/fpdfdoc/cpdf_formfield.cpp
core/fpdfdoc/cpdf_generateap.cpp
core/fpdfdoc/cpdf_icon.cpp
core/fpdfdoc/cpdf_iconfit.cpp
core/fpdfdoc/cpdf_interactiveform.cpp
core/fpdfdoc/cpdf_link.cpp
core/fpdfdoc/cpdf_linklist.cpp
core/fpdfdoc/cpdf_metadata.cpp
core/fpdfdoc/cpdf_nametree.cpp
core/fpdfdoc/cpdf_numbertree.cpp
core/fpdfdoc/cpdf_pagelabel.cpp
core/fpdfdoc/cpdf_structelement.cpp
core/fpdfdoc/cpdf_structtree.cpp
core/fpdfdoc/cpdf_viewerpreferences.cpp
core/fpdfdoc/cpvt_fontmap.cpp
core/fpdfdoc/cpvt_section.cpp
core/fpdfdoc/cpvt_variabletext.cpp
core/fpdfdoc/cpvt_wordinfo.cpp
core/fpdftext/cpdf_linkextract.cpp
core/fpdftext/cpdf_textpage.cpp
core/fpdftext/cpdf_textpagefind.cpp
core/fpdftext/unicodenormalizationdata.cpp
core/fxcodec/basic/basicmodule.cpp
core/fxcodec/data_and_bytes_consumed.cpp
core/fxcodec/fax/faxmodule.cpp
core/fxcodec/flate/flatemodule.cpp
core/fxcodec/fx_codec.cpp
core/fxcodec/icc/icc_transform.cpp
core/fxcodec/jbig2/JBig2_ArithDecoder.cpp
core/fxcodec/jbig2/JBig2_ArithIntDecoder.cpp
core/fxcodec/jbig2/JBig2_BitStream.cpp
core/fxcodec/jbig2/JBig2_Context.cpp
core/fxcodec/jbig2/JBig2_DocumentContext.cpp
core/fxcodec/jbig2/JBig2_GrdProc.cpp
core/fxcodec/jbig2/JBig2_GrrdProc.cpp
core/fxcodec/jbig2/JBig2_HtrdProc.cpp
core/fxcodec/jbig2/JBig2_HuffmanDecoder.cpp
core/fxcodec/jbig2/JBig2_HuffmanTable.cpp

=== src/fuse/common/CMakeLists.txt ===
add_subdirectory(
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../include/mega/fuse/common
    ${CMAKE_CURRENT_BINARY_DIR}/../../../include/mega/fuse/common
)

# Add sources required by all backends.
target_sources(SDKlib PRIVATE
                      any_lock_set.cpp
                      client.cpp
                      file_explorer_view.cpp
                      file_move_flag.cpp
                      inode_id.cpp
                      inode_info.cpp
                      logger.cpp
                      mount_event.cpp
                      mount_event_type.cpp
                      mount_flags.cpp
                      mount_info.cpp
                      mount_inode_id.cpp
                      mount_result.cpp
                      service.cpp
                      service_context.cpp
)

=== src/fuse/supported/CMakeLists.txt ===
# Add sources required by all concrete backends.
add_subdirectory(common)

# Add platform-specific sources.
add_subdirectory(platform)

=== src/fuse/unsupported/CMakeLists.txt ===
# Let the SDK know where it can find our headers.
target_include_directories(SDKlib PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

# Add sources required by dummy backend.
target_sources(SDKlib PRIVATE
                      service_context.cpp
                      service.cpp
)

add_subdirectory(mega)

=== include/mega/fuse/common/CMakeLists.txt ===
target_sources(SDKlib PRIVATE
                      any_lock.h
                      any_lock_forward.h
                      any_lock_set.h
                      any_lock_set_forward.h
                      client.h
                      file_explorer_view.h
                      file_move_flag.h
                      file_move_flag_forward.h
                      file_open_flag.h
                      file_open_flag_forward.h
                      inode_cache_flags.h
                      inode_cache_flags_forward.h
                      inode_id.h
                      inode_id_forward.h
                      inode_info.h
                      inode_info_forward.h
                      logger.h
                      logging.h
                      mount_event.h
                      mount_event_forward.h
                      mount_event_type.h
                      mount_event_type_forward.h
                      mount_flags.h
                      mount_flags_forward.h
                      mount_info.h
                      mount_info_forward.h
                      mount_inode_id.h
                      mount_inode_id_forward.h
                      mount_result.h
                      mount_result_forward.h
                      service.h
                      service_callbacks.h
                      service_context.h
                      service_context_forward.h
                      service_flags.h
                      service_flags_forward.h
                      service_forward.h
)

=== src/fuse/supported/common/CMakeLists.txt ===
target_include_directories(SDKlib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

target_sources(SDKlib PRIVATE
                      database_builder.cpp
                      directory_inode.cpp
                      file_cache.cpp
                      file_extension_db.cpp
                      file_info.cpp
                      file_inode.cpp
                      file_io_context.cpp
                      inode_cache.cpp
                      inode.cpp
                      inode_db.cpp
                      mount.cpp
                      mount_db.cpp
)

add_subdirectory(mega)
add_subdirectory(testing)

=== src/fuse/supported/platform/CMakeLists.txt ===
# Add sources required by all platforms.
target_include_directories(SDKlib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

target_sources(SDKlib PRIVATE
                      context.cpp
                      file_context.cpp
                      service.cpp
                      service_context.cpp
                      unmounter.cpp
)

# Add headers required by all platforms.
add_subdirectory(mega)

# Add tests common to all platforms.
add_subdirectory(testing)

# Add backend-specific sources.
if (UNIX)
    add_subdirectory(posix)
else()
    add_subdirectory(windows)
endif()

=== build/templates/megasdk/PKGBUILD ===
##
 # @file build/templates/sdk/PKGBUILD
 # @brief script to generate package sdk for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

pkgname=megasdk
pkgver=megasdk_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="MEGA SDK - Client Access Engine"
arch=('i686' 'x86_64')
url="https://mega.io/developers"
license=("https://github.com/meganz/sdk/blob/master/LICENSE")
groups=()
depends=('glibc>=2.37' 'qt5-base>=5.15' 'qt5-tools>=5.15' 'qt5-svg>=5.15' 'qt5-x11extras' 'qt5-graphicaleffects' 'qt5-quickcontrols2' 'qt5-quickcontrols')
makedepends=('unzip' 'wget' 'ca-certificates' 'qt5-tools' 'qt5-declarative' 'cmake' 'zip' 'python3' 'autoconf-archive' 'nasm')
checkdepends=()
optdepends=('sni-qt: fix systray issue on KDE and LXQt')
provides=("megasdk=${pkgver}")
replaces=()
backup=()
options=(!lto) # ffmpeg is not relocatable
install=megasdk.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz"
)
noextract=()
md5sums=('MD5SUM') # generated with makepkg -g
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
	if [ -f /opt/vcpkg.tar.gz ]; then
		tar xzf /opt/vcpkg.tar.gz
	fi
}

build() {
	set -x

	cd "$pkgname-$pkgver"
	megasrcdir="${PWD}"
	megabuilddir="${megasrcdir}/build_dir"

	if [ -d "${megasrcdir}/vcpkg" ]; then
		export VCPKG_DEFAULT_BINARY_CACHE=/opt/persistent/vcpkg_cache
		mkdir -p ${VCPKG_DEFAULT_BINARY_CACHE}
		vcpkg_root="-DVCPKG_ROOT=${megasrcdir}/vcpkg"
	fi

	cmake --version
	cmake ${vcpkg_root} -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo -DENABLE_QT_BINDINGS=ON -DENABLE_LOG_PERFORMANCE=ON -DUSE_LIBUV=ON -S "${megasrcdir}" -B "${megabuilddir}"
	cmake --build "${megabuilddir}" ${BUILD_PARALLEL_JOBS}


	touch build-stamp
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	megasrcdir="${srcdir}/${pkgname}-${pkgver}"
	megabuilddir="${megasrcdir}/build_dir"
	
	cmake --install "${megabuilddir}" --prefix $pkgdir
}
